#include <bits/stdc++.h>

using namespace std;

long long a[75000],b[75000];


long long gcd(long long a1,long long a2){
    if(a1==0){
        return a2;
    }
    return gcd(a2%a1,a1);
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    long long t,i,p,q;
    cin>>t;
    for(int ii=0;ii<t;ii++){
        long long n,m;
        cin>>n>>m;
        for(i=0;i<n;i++){
            cin>>a[i];
        }
        for(i=0;i<m;i++){
            cin>>b[i];
        }
        sort(a,a+n);
        p=a[1]-a[0];
        for(i=1;i<n-1;i++){
            p=gcd(p,a[i+1]-a[i]);
        }
        q=1;
        for(i=0;i<m;i++){
            if((b[i]-a[0])%p==0){
                q=0;
            }
        }
        cout<<q<<"\n";
    }
    return 0;
}